/*
	File:		Newton.h

	Contains:	Newton C++ Tools errors, types, memory, and debug, widgets.

	Written by:	Newton Research Group.
*/

#if !defined(__NEWTON_H)
#define __NEWTON_H 1

/*------------------------------------------------------------------------------
	Standard C/C++ includes.
------------------------------------------------------------------------------*/

// malloc, free
#if !defined(__STDLIB__)
#include <stdlib.h>
#endif

// strcpy, memmove
#if !defined(__STRING__)
#include <string.h>
#endif

// size_t et al.
#if !defined(__STDDEF__)
#include <stddef.h>
#endif

/*------------------------------------------------------------------------------
	Platform includes.
------------------------------------------------------------------------------*/

#if !defined(__NEWTONTYPES_H)
#include "NewtonTypes.h"
#endif

#if !defined(__NEWTONWIDGETS_H)
#include "NewtonWidgets.h"
#endif

#if !defined(__NEWTONMEMORY_H)
#include "NewtonMemory.h"
#endif

#if !defined(__NEWTONEXCEPTIONS_H)
#include "NewtonExceptions.h"
#endif

#if !defined(__NEWTONDEBUG_H)
#include "NewtonDebug.h"
#endif

#if !defined(__NEWTONERRORS_H)
#include "NewtonErrors.h"
#endif

#endif	/* __NEWTON_H */
