/*
	File:		NewtonScript.h

	Contains:	NewtonScript interface for Newton C Tools.

	Written by:	Newton Research Group.
*/

#if !defined(__NEWTONSCRIPT_H)
#define	__NEWTONSCRIPT_H 1

#if !defined(__OBJECTS_H)
#include "Objects.h"
#endif


/*------------------------------------------------------------------------------
	NewtonScript

	Callbacks to NewtonScript functions from C++
------------------------------------------------------------------------------*/

Ref NSCall(RefArg fn);
Ref NSCall(RefArg fn, RefArg arg0);
Ref NSCall(RefArg fn, RefArg arg0, RefArg arg1);
Ref NSCall(RefArg fn, RefArg arg0, RefArg arg1, RefArg arg2);
Ref NSCall(RefArg fn, RefArg arg0, RefArg arg1, RefArg arg2, RefArg arg3);
Ref NSCall(RefArg fn, RefArg arg0, RefArg arg1, RefArg arg2, RefArg arg3, RefArg arg4);
Ref NSCall(RefArg fn, RefArg arg0, RefArg arg1, RefArg arg2, RefArg arg3, RefArg arg4, RefArg arg5);
Ref NSCallWithArgArray(RefArg fn, RefArg args);

Ref NSCallGlobalFn(RefArg sym);
Ref NSCallGlobalFn(RefArg sym, RefArg arg0);
Ref NSCallGlobalFn(RefArg sym, RefArg arg0, RefArg arg1);
Ref NSCallGlobalFn(RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2);
Ref NSCallGlobalFn(RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2, RefArg arg3);
Ref NSCallGlobalFn(RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2, RefArg arg3, RefArg arg4);
Ref NSCallGlobalFn(RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2, RefArg arg3, RefArg arg4, RefArg arg5);
Ref NSCallGlobalFnWithArgArray(RefArg sym, RefArg args);

Ref NSSend(RefArg rcvr, RefArg sym);
Ref NSSend(RefArg rcvr, RefArg sym, RefArg arg0);
Ref NSSend(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1);
Ref NSSend(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2);
Ref NSSend(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2, RefArg arg3);
Ref NSSend(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2, RefArg arg3, RefArg arg4);
Ref NSSend(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2, RefArg arg3, RefArg arg4, RefArg arg5);
Ref NSSendWithArgArray(RefArg rcvr, RefArg sym, RefArg args);

Ref NSSendIfDefined(RefArg rcvr, RefArg sym);
Ref NSSendIfDefined(RefArg rcvr, RefArg sym, RefArg arg0);
Ref NSSendIfDefined(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1);
Ref NSSendIfDefined(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2);
Ref NSSendIfDefined(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2, RefArg arg3);
Ref NSSendIfDefined(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2, RefArg arg3, RefArg arg4);
Ref NSSendIfDefined(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2, RefArg arg3, RefArg arg4, RefArg arg5);
Ref NSSendIfDefinedWithArgArray(RefArg rcvr, RefArg sym, RefArg args);

Ref NSSendProto(RefArg rcvr, RefArg sym);
Ref NSSendProto(RefArg rcvr, RefArg sym, RefArg arg0);
Ref NSSendProto(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1);
Ref NSSendProto(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2);
Ref NSSendProto(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2, RefArg arg3);
Ref NSSendProto(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2, RefArg arg3, RefArg arg4);
Ref NSSendProto(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2, RefArg arg3, RefArg arg4, RefArg arg5);
Ref NSSendProtoWithArgArray(RefArg rcvr, RefArg sym, RefArg args);

Ref NSSendProtoIfDefined(RefArg rcvr, RefArg sym);
Ref NSSendProtoIfDefined(RefArg rcvr, RefArg sym, RefArg arg0);
Ref NSSendProtoIfDefined(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1);
Ref NSSendProtoIfDefined(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2);
Ref NSSendProtoIfDefined(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2, RefArg arg3);
Ref NSSendProtoIfDefined(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2, RefArg arg3, RefArg arg4);
Ref NSSendProtoIfDefined(RefArg rcvr, RefArg sym, RefArg arg0, RefArg arg1, RefArg arg2, RefArg arg3, RefArg arg4, RefArg arg5);
Ref NSSendProtoIfDefinedWithArgArray(RefArg rcvr, RefArg sym, RefArg args);


#endif	/* __NEWTONSCRIPT_H */
